<template>
  <div>
    <el-button @click="loginWith('google')">Login with Google</el-button>
    <div v-show="mode == 'register'">
      <el-form
        ref="registerForm"
        :model="registerData"
        @submit.native.prevent="$refs.registerButton.onClick"
        :rules="registerRules"
      >
        <el-form-item label="Name" prop="name">
          <el-input v-model="registerData.name" />
        </el-form-item>
        <el-form-item label="Username" prop="username">
          <el-input v-model="registerData.username" spellcheck="false" />
        </el-form-item>
        <el-form-item label="Email" prop="email">
          <el-input v-model="registerData.email" />
        </el-form-item>
        <el-form-item label="Password" prop="password">
          <el-input
            v-model="registerData.password"
            show-password
            @keyup.enter="$refs.registerButton.onClick"
          />
        </el-form-item>

        <el-alert
          v-if="error"
          :title="error.message"
          type="error"
          effect="dark"
          @click="error = null"
        />

        <el-form-item>
          <el-button
            type="primary"
            ref="registerButton"
            @click="performRegister"
            >Register</el-button
          >
        </el-form-item>
      </el-form>
    </div>
    <div v-show="mode == 'login'">
      <el-form :model="loginData" @submit.native.prevent="performLogin">
        <el-form-item label="Username">
          <el-input v-model="loginData.username" />
        </el-form-item>
        <el-form-item label="Password">
          <el-input
            v-model="loginData.password"
            show-password
            @keyup.enter="$refs.loginButton.onClick"
          />
        </el-form-item>

        <el-alert
          v-if="error"
          :title="error.message"
          type="error"
          effect="dark"
          @click="error = null"
        />

        <el-form-item>
          <stateful-button
            ref="loginButton"
            type="primary"
            @click="performLogin"
            >Login</stateful-button
          >
          <el-button type="secondary" @click="mode = 'forgot'"
            >Request Reset Email</el-button
          >
        </el-form-item>
      </el-form>
    </div>
    <div v-show="mode == 'forgot'">
      <el-form :model="forgotData" @submit.native.prevent="performForgot">
        <el-form-item label="Email">
          <el-input v-model="forgotData.email" />
        </el-form-item>

        <el-alert
          v-if="error"
          :title="error.message"
          type="error"
          effect="dark"
          @click="error = null"
        />

        <el-alert v-if="message" :title="message" type="info" effect="dark" />

        <el-form-item>
          <el-button type="primary" @click="performForgot"
            >Request Reset Email</el-button
          >
        </el-form-item>
      </el-form>
    </div>

    <a v-if="mode != 'login'" @click="mode = 'login'">Login</a>
    <a v-if="mode != 'register'" @click="mode = 'register'">Register</a>
  </div>
</template>
<script>
const FIELDS = `
    user {
      id isAdmin isVerified userEmails { nodes { id email isVerified } }
    }
`;

const LOGIN_MUTATION = `
mutation($username:String!,$password:String!) {
  _:login(input: { username:$username , password:$password }) {
${FIELDS}
  }
}`;

const REGISTER_MUTATION = `
mutation($username:String!,$password:String!,$email:String!,$name:String) {
 	_:register(input: { username:$username , password:$password, email: $email, name: $name }) {
${FIELDS}
  }
}
`;

const FORGOT_MUTATION = `
mutation($email:String!) {
  forgotPassword(input: { email: $email }) {
    clientMutationId
  }
}
`;

export default {
  props: {
    login: { type: Boolean, default: false },
    register: { type: Boolean, default: false },
    then: { type: String, default: "/" },
  },
  data() {
    let mode;

    if (this.login && this.register) mode = null;
    else if (this.login) mode = "login";
    else if (this.register) mode = "register";

    return {
      mode: mode,

      error: null,
      message: null,

      loginData: {},
      registerData: {},
      forgotData: {},

      registerRules: {
        email: {
          required: true,
          trigger: "blur",
          pattern: /^\w+([\.-]?\w+)*@\w+([\.-]?\w+)*(\.\w{2,})+$/,
          message: "Please input a valid email",
        },
        password: { required: true, trigger: "blur", min: 8 },
        username: {
          required: true,
          trigger: "blur",
          message: "username can only have letters and underscores",
          pattern: /^[a-z_A-Z]{3,}$/,
        },
        name: { required: true, trigger: "blur", min: 3 },
      },
    };
  },
  methods: {
    loginWith(provider) {
      document.location = `/auth/${provider}?then=${encodeURIComponent(
        this.$route.fullPath
      )}`;
    },

    handle(result) {
      this.$store.commit("user", result.user);
      // this.$router.push(this.then);
    },

    async performLogin() {
      this.error = null;
      const { result, error } = await this.$gql(LOGIN_MUTATION, this.loginData);
      if (error) return (this.error = error);

      this.handle(result._);
    },

    async performForgot() {
      this.error = null;
      const { result, error } = await this.$gql(
        FORGOT_MUTATION,
        this.forgotData
      );

      if (error) return (this.error = error);
      this.message =
        "If this email exists in our system, an email has been sent to it.";
    },

    async performRegister() {
      this.error = null;

      const valid = await this.$refs.registerForm.validate();
      console.log("Valid? ", valid);
      if (!valid) return;

      const { result, error } = await this.$gql(
        REGISTER_MUTATION,
        this.registerData
      );
      if (error) return (this.error = error);

      this.handle(result._);
    },
  },
};
</script>
